//+------------------------------------------------------------------+
//|                                                          KST.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DASHDOT

//
//
//
//
//

extern int KSTType           = 0;
extern int KSTMaType         = 1;
extern int KSTSignalMaPeriod = 9;

//
//
//
//
//

double kst[];
double kstda[];
double kstdb[];
double kstSignal[];
double trend[];
double paramr[4];
double paramm[4];
double koef = 1;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   KSTType   = MathMax(MathMin(KSTType  ,2),0);   
   KSTMaType = MathMax(MathMin(KSTMaType,1),0);   
   
   //
   //
   //
   //
   //
   
   string name = "";
   
     switch (KSTMaType)
     {
         case 0 :
            switch (KSTType)
            {
               case 0 :
                     paramr[0] = 10; paramr[1] = 15; paramr[2] = 20; paramr[3] = 30; 
                     paramm[0] = 10; paramm[1] = 10; paramm[2] = 10; paramm[3] = 15;
                     name = "Short term SMA KST ";
                     break;
               case 1 :                     
                     paramr[0] = 10; paramr[1] = 13; paramr[2] = 15; paramr[3] = 20;
                     paramm[0] = 10; paramm[1] = 13; paramm[2] = 15; paramm[3] = 20;
                     name = "Intermediate term SMA KST ";
                     break;
               case 2:                     
                     paramr[0] =  9; paramr[1] = 12; paramr[2] = 18; paramr[3] = 24;
                     paramm[0] =  6; paramm[1] =  6; paramm[2] =  6; paramm[3] =  9; koef = 4;
                     name = "Long term SMA KST ";
                     break;
            }
            break;

         //
         //
         //
         //
         //
                     
         case 1 :            
            switch (KSTType)
            {
               case 0 :
                     paramr[0] = 3; paramr[1] = 4; paramr[2] = 6; paramr[3] = 10; 
                     paramm[0] = 3; paramm[1] = 4; paramm[2] = 6; paramm[3] =  8;
                     name = "Short term EMA KST ";
                     break;
               case 1 :                     
                     paramr[0] = 10; paramr[1] = 13; paramr[2] = 15; paramr[3] = 20;
                     paramm[0] = 10; paramm[1] = 13; paramm[2] = 15; paramm[3] = 20;
                     name = "Intermediate term EMA KST ";
                     break;
               case 2:                     
                     paramr[0] = 39; paramr[1] = 52; paramr[2] = 78; paramr[3] = 109;
                     paramm[0] = 26; paramm[1] = 26; paramm[2] = 26; paramm[3] =  39;
                     name = "Long term EMA KST ";
                     break;
            }
      }

   //
   //
   //
   //
   //
   
   IndicatorBuffers(5);                  
   SetIndexBuffer(0,kst);
   SetIndexBuffer(1,kstda);
   SetIndexBuffer(2,kstdb);
   SetIndexBuffer(3,kstSignal);
   SetIndexBuffer(4,trend);
   
   IndicatorShortName(name);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][4];

//
//
//
//
//

int start()
{
   int limit,i,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   if (trend[limit] == -1) ClearPoint(limit,kstda,kstdb);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      for (int k=0; k<4; k++) work[r][k] = iROC(paramr[k],i);
         if (KSTMaType==0)
               kst[i] = (iSMA(0,r)+iSMA(1,r)*2.0+iSMA(2,r)*3.0+iSMA(3,r)*4.0)/koef;
         else  kst[i] = (iEMA(0,r)+iEMA(1,r)*2.0+iEMA(2,r)*3.0+iEMA(3,r)*4.0)/koef;
      
      double sum = 0; for (k=0; k<KSTSignalMaPeriod; k++) sum += kst[i+k];
               kstSignal[i] = sum/KSTSignalMaPeriod; 
               trend[i]     = trend[i+1];
      if (kst[i] > 0) trend[i] =  1;
      if (kst[i] < 0) trend[i] = -1;
      if (trend[i] == -1) PlotPoint(i,kstda,kstdb,kst);     
   }
   return(0);
}


//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

double iROC(int period, int shift)
{
   double ROC;

   if (Close[shift + period] != 0)
          ROC = (Close[shift]-Close[shift + period]) / Close[shift + period];
   else   ROC = 0.00;
   return(ROC);
}

//
//
//
//
//

double iSMA(int forBuffer, int r)
{
   double sum=0;
   for (int k=0; k<paramm[forBuffer] && (r-k)>=0; k++) sum += work[r-k][forBuffer];
        return(sum/paramm[forBuffer]);
}

//
//
//
//
//

double workEma[][4];
double iEMA(int forBuffer, int r)
{
   if (ArrayRange(workEma,0)!=Bars) ArrayResize(workEma,Bars);
   if (r==0) 
      workEma[r][forBuffer] = work[r][forBuffer];
   else
   {
      double alpha = 2.0/(1.0+paramm[forBuffer]);
         workEma[r][forBuffer] = workEma[r-1][forBuffer]+alpha*(work[r][forBuffer]-workEma[r-1][forBuffer]);
   }      
   return(workEma[r][forBuffer]);
}

//
//
//
//
//

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}